#ifndef DAG_H_
#define DAG_H_

#include "topology.h"

typedef struct DagNode DagNode;

struct DagNode
{
  Triangle *t;
  DagNode **children;
  int n;
  int visited;
};

DagNode *makeDagNode (Triangle * t);
void append2Children (DagNode * node, DagNode * c1, DagNode * c2);
void append3Children (DagNode * node, DagNode * c1, DagNode * c2, DagNode * c3);
DagNode *findTriangle (Vertex * v, DagNode * dag);
int getTriangulation(DagNode *node, Triangle **triangles);
int boundaryTriangle(Triangle *t);
void freeDag(DagNode *node);
#endif /*DAG_H_*/
