#ifndef GEOMETRY_H_
#define GEOMETRY_H_

typedef struct Point2 Point2;
typedef struct Point3 Point3;

struct Point2
{
  double x, y;
};

struct Point3
{
  double x, y, z;
};

double det3x3 (Point3 a, Point3 b, Point3 c);
double tao (Point3 a, Point3 b, Point3 c, Point3 d);
int incircle (Point2 a, Point2 b, Point2 c, Point2 d);
int inTriangle (Point2 *a, Point2 *b, Point2 *c, Point2 *d);
Point2* makePoint2 (double x, double y);
Point2* barycenter(Point2 *a, Point2 *b, Point2 *c);
int leftTurn(Point2 a, Point2 b, Point2 c);
void freePoint2(Point2 *p);
#endif /*GEOMETRY_H_ */
